#define _GNU_SOURCE
#include <stdio.h>
#include <sys/time.h>
#include <string.h>
#include <semaphore.h>
#include <sched.h>
#include <pthread.h>
#include <assert.h>

#define TIME_DIFF(t1, t2) \
		((t2.tv_sec - t1.tv_sec) * 1000000 + (t2.tv_usec - t1.tv_usec))

#define NTHREADS 2
int res[NTHREADS];

struct thread_arg {
	int num;
	int cpu;
	volatile void *addr;
	sem_t sem;
};

void *thread_fun(void *_arg) {
	struct thread_arg *arg = _arg;
	int cpu = arg->cpu;
	int num = arg->num;
	volatile int *a = arg->addr;
	cpu_set_t mask;
	int i=0;
	struct timeval tvlast, tvnew;

	/* on a fini de copier les arguments */
	sem_post(&arg->sem);

	/* se placer sur le processeur demand */
	CPU_ZERO(&mask);
	CPU_SET(cpu, &mask);
	if (sched_setaffinity(0, sizeof(mask), &mask)) {
		perror("sched_setaffinity");
		exit(1);
	}

	gettimeofday(&tvlast, NULL);
	while(1) {
		*a = 1000000;
		while (*a>0) {
			(*a)--;
		}
		i++;
		gettimeofday(&tvnew, NULL);
		if (TIME_DIFF(tvlast,tvnew)>1000000) {
			res[num] = i;
			if (!num) {
				int j;
				fprintf(stderr,"\r");
				for (j = 0; j<NTHREADS; j++)
					fprintf(stderr,"%d\t",res[j]);
			}
			i=0;
			memcpy(&tvlast,&tvnew,sizeof(tvlast));
		}
	}
	return NULL;
}

void lance_thread(int cpu, volatile void *addr, struct thread_arg *arg) {
	static int num = 0;
	pthread_t t;
	assert(num<NTHREADS);
	sem_init(&arg->sem, 0, 0);
	(*arg).num = num;
	(*arg).cpu = cpu;
	(*arg).addr = addr;
	pthread_create(&t, NULL, thread_fun, arg);
	/* attendre que le thread ait fini de copier les arguments */
	sem_wait(&(*arg).sem);
	num++;
}

volatile char tab[1024];

int main(int argc, char *argv[]) {
	struct thread_arg arg1;
	struct thread_arg arg2;

	if (argc != 4) printf(" 3 parametres : ecart proc1 proc2\n");
	
	lance_thread(atoi(argv[2]), &tab[0],&arg1);
	lance_thread(atoi(argv[3]), &tab[atoi(argv[1])],&arg2);

	/* terminer le thread principal et laisser les autres tourner */
	pthread_exit(NULL);
}
