#include <sys/time.h>
#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <sys/stat.h>

void verrou(void) {
  mode_t oldmode;
  /* Utilisation d'un verrou inter-processus pour éviter que vous vous
   * marchiez les uns sur les autres */
  oldmode = umask(0);
  int fd = open("/var/tmp/verrou-PAP", O_WRONLY|O_CREAT, 0777);
  if (fd < 0) {
    perror("open");
    exit(1);
  }
  umask(oldmode);
  if (lockf(fd, F_LOCK, 0)) {
    perror("lockf");
    exit(1);
  }
}

#define TIME_DIFF(t1, t2) \
	((t2.tv_sec - t1.tv_sec) * 1000000 + (t2.tv_usec - t1.tv_usec))

#define N 4096
typedef float matrix[N][N] __attribute__((aligned(4096)));

matrix A,B,C;

void fillmatrix(matrix A) {
	int i,j;
	for (i=0;i<N;i++)
		for (j=0;j<N;j++)
			A[i][j] = drand48();
}

void addcosinmatrix(matrix A, matrix B, matrix C) {
	int i,j;
	for (i=0;i<N;i++)
		for (j=0;j<N;j++)
			C[i][j] = cos(A[i][j]) + sin(B[i][j]);
}

void addmatrix(matrix A, matrix B, matrix C) {
	int i,j;
	for (i=0;i<N;i++)
		for (j=0;j<N;j++)
			C[i][j] = A[i][j] + B[i][j];
}

float total;
void totalmatrix(matrix A) {
	int i,j;
	total = 0;
	for (i=0;i<N;i++)
		for (j=0;j<N;j++)
			total += sin(A[i][j]);
}


int main(void) {
	struct timeval tv1,tv2;

	verrou();

	fillmatrix(A);
	fillmatrix(B);
	fillmatrix(C);

	gettimeofday(&tv1,NULL);
	addmatrix(A,B,C);
	gettimeofday(&tv2,NULL);

	printf("%f ms\n", ((float)TIME_DIFF(tv1,tv2)) / 1000);

	gettimeofday(&tv1,NULL);
	addcosinmatrix(A,B,C);
	gettimeofday(&tv2,NULL);

	printf("%f ms\n", ((float)TIME_DIFF(tv1,tv2)) / 1000);

	return 0;
}
