#define _GNU_SOURCE /* pour pouvoir utiliser CPU_SET, CPU_ZERo, etc. */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>
#include <time.h>
#include <sched.h>
/* ne *pas* mettre de -O, sinon gcc arrive  liminer les latences (et il optimise les oprations dbiles */

#define TIME_DIFF(t1, t2) \
	((t2.tv_sec - t1.tv_sec) * 1000000 + (t2.tv_usec - t1.tv_usec))

#define MAX 1024*1024*1024UL
#define gold ((float)N*((sqrt(5)-1.)/2.))

int N;
char *a;

void generateTab(char* t) {
	int i;
	for(i=0;i<N;i++)
	  t[i]=i+1;
}

int sumTab(char* a) {
  int i,j,k,l;
	int masque=N-1; // 0..01..11
	l = 2; k=1; j=0;


	for(i=0;i<2000000;i++){
		j+=a[j]+gold;
		j&=masque;
	}
	return j;
}

int main(int argc, char ** argv){
	struct timeval tv1,tv2;
	cpu_set_t cpusbind;
	CPU_ZERO(&cpusbind);
	CPU_SET(0,&cpusbind);
	if (sched_setaffinity(0, sizeof(cpusbind), &cpusbind)) {
		perror("sched_setaffinity");
		exit(EXIT_FAILURE);
	}
	a = malloc(MAX);
	a[0] = 0;
	int s=0;
	for(N=2;N<MAX;N*=2) {
		generateTab(a);
		gettimeofday(&tv1,NULL);
		s+=sumTab(a);
		gettimeofday(&tv2,NULL);
		printf("%d\t%4lu\n", N, TIME_DIFF(tv1,tv2));
	}

	return s;
}
